/*
ID: espr1t
TASK: SuperMario
KEYWORDS: Medium, DP, Inner Cycle Optimization
*/

#include <cstdio>
#include <queue>
#include <ctime>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

int main(void) {
    int numTests = 20;
    for (int test = 0; test <= numTests; test++) {
        unsigned sTime = clock();
        fprintf(stderr, "Solving testcase %d...\n", test);

        char inpFile[32], solFile[32];
        sprintf(inpFile, "SuperMario.%02d.in", test);
        sprintf(solFile, "SuperMario.%02d.sol", test);
        
        FILE* in = fopen(inpFile, "rt");
        int n, k;
        int F, A, B, M;
        fscanf(in, "%d %d", &n, &k);
        fscanf(in, "%d %d %d %d", &F, &A, &B, &M);
    
        long long ans = (long long)n * M;
        deque < pair <long long, int> > q(1, make_pair(0, -1));
        for (int i = 0; i < n; i++) {
            while (!q.empty() && i - k > q.front().second)
                q.pop_front();
    
            pair <long long, int> cur = make_pair(F + q.front().first, i);
            F = (int)(((long long)F * A + B) % M);
    
            while (!q.empty() && q.back().first >= cur.first)
                q.pop_back();
            q.push_back(cur);
    
            if (i + k >= n)
                ans = min(ans, cur.first);
        }
        ans = k > n ? 0LL : ans;
        fclose(in);
        
        FILE* sol = fopen(solFile, "rt");
        long long real;
        fscanf(sol, "%lld", &real);
        fclose(sol);

        fprintf(stderr, "  >> execution time: %.3lfs\n",
            (double)(clock() - sTime) / CLOCKS_PER_SEC);
        fprintf(stderr, "  >> %s (real is %lld, ans is %lld)\n",
            real == ans ? "OK" : "WA", real, ans);
    }
    return 0;
}
